------------------------------
--      Are you local?      --
------------------------------

local roster = nil
local parser = ParserLib:GetInstance("1.1")
local times = {}

local db

----------------------------
--      Localization      --
----------------------------

local L = AceLibrary("AceLocale-2.2"):new("WitchHunt")

L:RegisterTranslations("enUS", function() return {
	["combatonly"] = true,
	["Combat Only"] = true,
	["Toggle combat only mode."] = true,

	["targetonly"] = true,
	["Target Only"] = true,
	["Toggle target only mode."] = true,

	["lock"] = true,
	["Lock"] = true,
	["Toggle locking of the WitchHunt frame."] = true,

	["display"] = true,
	["Display Mode"] = true,
	["Select behavior for display of messages."] =true,

	["None"] = true,
	["Default"] = true,
	["Error Frame"] = true,
	["Mik's Scrolling Battle Text"] = true,
	["Scrolling Combat Text"] = true,
	["Scrolling Combat Text Message"] = true,
	
	["msbtArea"] = true,
	["MSBT Scroll Area"] = true,
	["Select Mik's Scrolling Battle Text output area"] = true,
	
	["msbtSticky"] = true,
	["Sticky type for MSBT"] = true,
	["Toggle sticky text type for Mik's Scrolling Battle Text"] = true,

	["font"] = true,
	["Font"] = true,
	["Set the font for the display of messages in the Default frame."] = true,

	["height"] = true,
	["Height"] = true,
	["Set the height for the Default frame."] = true,

	["Small"] = true,
	["Normal"] = true,
	["Large"] = true,
	["Huge"] = true,

	["test"] = true,
	["Test"] = true,
	["Test with some dummy WitchHunt messages."] = true,

	["insertmode"] = true,
	["Insert Mode"] = true,
	["Set the insert mode for the Default frame."] = true,
	["Bottom"] = true,
	["Top"] = true,

	["DRAG HERE"] = true,
} end )

L:RegisterTranslations("koKR", function() return {
	["Combat Only"] = "전투에 한정",
	["Toggle combat only mode."] = "전투에 한정 모드를 전환 합니다",

	["Target Only"] = "대상에 한정",
	["Toggle target only mode."] = "대상에 한정 모드를 전환 합니다",

	["Lock"] = "고정",
	["Toggle locking of the WitchHunt frame."] = "WitchHunt 프레임 고정 기능을 전환 합니다",

	["Display Mode"] = "표시 모드",
	["Select behavior for display of messages."] ="메시지 표시 방법을 선택합니다",

	["None"] = "없음",
	["Default"] = "기본",
	["Error Frame"] = "오류 프레임",
	["Mik's Scrolling Battle Text"] = "MSBT",
	["Scrolling Combat Text"] = "SCT",
	["Scrolling Combat Text Message"] = "SCT 메시지",
	
	["MSBT Scroll Area"] = "MSBT 스크롤 영역",
	["Select Mik's Scrolling Battle Text output area"] = "MSBT 표시 영역을 선택하세요.",
	
	["Sticky type for MSBT"] = "MSBT 고정 형태",
	["Toggle sticky text type for Mik's Scrolling Battle Text"] = "MSBT 고정 형태 사용을 전환합니다.",

	["Font"] = "글꼴",
	["Set the font for the display of messages in the Default frame."] = "기본 프레임에 표시할 메시지의 글꼴을 설정합니다",

	["Height"] = "높이",
	["Set the height for the Default frame."] = "기본 프레임의 높이를 설정합니다.",

	["Small"] = "작게",
	["Normal"] = "보통",
	["Large"] = "크게",
	["Huge"] = "매우크게",

	["Test"] = "테스트",
	["Test with some dummy WitchHunt messages."] = "몇개의 가짜 메시지로 테스트를 합니다",

	["Insert Mode"] = "추가 모드",
	["Set the insert mode for the Default frame."] = "기본 프레임에 추가 모드를 설정합니다",
	["Bottom"] = "아래",
	["Top"] = "위",

	["DRAG HERE"] = "여기를 끌면 됩니다",
} end )

L:RegisterTranslations("zhTW", function() return {
	["combatonly"] = "combatonly", -- no need to translate
	["Combat Only"] = "只限戰鬥",
	["Toggle combat only mode."] = "切換只限戰鬥模式。",

	["targetonly"] = "targetonly", -- no need to translate
	["Target Only"] = "只限目標",
	["Toggle target only mode."] = "切換只限目標模式。",

	["lock"] = "lock", -- no need to translate
	["Lock"] = "鎖定",
	["Toggle locking of the WitchHunt frame."] = "切換鎖定 WitchHunt 框架。",

	["display"] = "display", -- no need to translate
	["Display Mode"] = "顯示模式",
	["Select behavior for display of messages."] = "選擇訊息顯示模式。",

	["None"] = "無",
	["Default"] = "預設",
	["Error Frame"] = "錯誤框架",
	["Mik's Scrolling Battle Text"] = "Mik's Scrolling Battle Text",
	["Scrolling Combat Text"] = "Scrolling Combat Text",
	["Scrolling Combat Text Message"] = "Scrolling Combat Text 靜態訊息",
	
	["msbtArea"] = "msbtArea", -- no need to translate
	["MSBT Scroll Area"] = "MSBT 捲動區域",
	["Select Mik's Scrolling Battle Text output area"] = "選擇 Mik's Scrolling Battle Text 輸出區域。",
	
	["msbtSticky"] = "msbtSticky", -- no need to translate
	["Sticky type for MSBT"] = "MSBT 粘性類型",
	["Toggle sticky text type for Mik's Scrolling Battle Text"] = "切換 Mik's Scrolling Battle Text 粘性類型。",

	["font"] = "font", -- no need to translate
	["Font"] = "字形",
	["Set the font for the display of messages in the Default frame."] = "設定預設框架的字形。",

	["height"] = "height", -- no need to translate
	["Height"] = "高度",
	["Set the height for the Default frame."] = "設定預設框架的高度。",

	["Small"] = "小",
	["Normal"] = "正常",
	["Large"] = "大",
	["Huge"] = "極大",

	["test"] = "test", -- no need to translate
	["Test"] = "測試",
	["Test with some dummy WitchHunt messages."] = "測試 WitchHunt。",

	["insertmode"] = "insertmode", -- no need to translate
	["Insert Mode"] = "插入模式",
	["Set the insert mode for the Default frame."] = "設定預設框架的插入模式。",
	["Bottom"] = "底部",
	["Top"] = "頂部",

	["DRAG HERE"] = "在此拖動",
} end )

local defaults = {
	combatonly = false,
	targetonly = false,
	display = L["Default"],
	font = L["Normal"],
	lock = true,
	insertmode = L["Top"],
	msbtSticky = false,
	height = 160,
}

local consoleoptions = {
	type = "group",
	args = {
		[L["combatonly"]] = {
			name = L["Combat Only"], type = "toggle",
			desc = L["Toggle combat only mode."],
			get = function() return WitchHunt.db.profile.combatonly end,
			set = function(v)
				WitchHunt.db.profile.combatonly = v
			end,
		},
		[L["targetonly"]] = {
			name = L["Target Only"], type = "toggle",
			desc = L["Toggle target only mode."],
			get = function() return WitchHunt.db.profile.targetonly end,
			set = function(v)
				WitchHunt.db.profile.targetonly = v
			end,
		},
		[L["lock"]] = {
			name = L["Lock"], type = "toggle",
			desc = L["Toggle locking of the WitchHunt frame."],
			get = function() return WitchHunt.db.profile.lock end,
			set = function(v)
				WitchHunt.db.profile.lock = v
				WitchHunt:UpdateLock()
			end,
		},
		[L["insertmode"]] = {
			name = L["Insert Mode"], type = "text",
			desc = L["Set the insert mode for the Default frame."],
			validate = { L["Top"], L["Bottom"] },
			get = function() return WitchHunt.db.profile.insertmode end,
			set = function(v)
				WitchHunt.db.profile.insertmode = v
				if WitchHunt.msgframe then
					if v == L["Bottom"] then
						WitchHunt.msgframe:SetInsertMode("BOTTOM")
					else
						WitchHunt.msgframe:SetInsertMode("TOP")
					end
				end
			end,
		},
		[L["display"]] = {
			name = L["Display Mode"], type = "text",
			desc = L["Select behavior for display of messages."],
			validate = {L["None"], L["Default"], L["Error Frame"]},
			get = function() return WitchHunt.db.profile.display end,
			set = function(v)
				WitchHunt.db.profile.display = v
				if v == L["None"] then
				if WitchHunt:IsEventRegistered("WitchHunt_Message") then WitchHunt:UnregisterEvent("WitchHunt_Message") end
				else
				if not WitchHunt:IsEventRegistered("WitchHunt_Message") then WitchHunt:RegisterEvent("WitchHunt_Message") end
				end
			end,
		},
		[L["msbtArea"]] = {
			name = L["MSBT Scroll Area"], type = "text",
			desc = L["Select Mik's Scrolling Battle Text output area"],
			validate = {},
			get = function() return WitchHunt.db.profile.msbtArea end,
			set = function(v)
				WitchHunt.db.profile.msbtArea = v
			end,
			hidden = not MikSBT,
		},
		[L["msbtSticky"]] = {
			name = L["Sticky type for MSBT"], type = "toggle",
			desc = L["Toggle sticky text type for Mik's Scrolling Battle Text"],
			get = function() return WitchHunt.db.profile.msbtSticky end,
			set = function(v)
				WitchHunt.db.profile.msbtSticky = v
			end,
			hidden = not MikSBT,
		},
		[L["font"]] = {
			name = L["Font"], type = "text",
			desc = L["Set the font for the display of messages in the Default frame."],
			validate = {L["Small"], L["Normal"], L["Large"], L["Huge"]},
			get = function() return WitchHunt.db.profile.font end,
			set = function(v)
				WitchHunt.db.profile.font = v
				WitchHunt:SetFont()
			end,
		},
		[L["height"]] = {
			name = L["Height"], type = "range",
			desc = L["Set the height for the Default frame."],
			min = 40,
			max = 200,
			step = 5,
			get = function() return WitchHunt.db.profile.height end,
			set = function(v)
				WitchHunt.db.profile.height = v
				if WitchHunt.msgframe then
					WitchHunt.msgframe:SetHeight( v )
				end
			end,			
		},
		[L["test"]] = {
			name = L["Test"], type = "execute",
			desc = L["Test with some dummy WitchHunt messages."],
			func = function()
				WitchHunt:TriggerEvent("WitchHunt_Message", "[Ammo: See it works!]", "Orange")
				WitchHunt:ScheduleEvent("WitchHunt_Message", 1, "*Ammo: extra code*", "Yellow")
				WitchHunt:ScheduleEvent("WitchHunt_Message", 2, "+Ammo: Super duper strength+", "LtBlue")
			end,
		}	
	}	
}

if MikSBT then
	table.insert(consoleoptions.args.display.validate, L["Mik's Scrolling Battle Text"])

	for _, saSettings in pairs(MSBTProfiles.CurrentProfile.ScrollAreaSettings) do
		table.insert(consoleoptions.args.msbtArea.validate, saSettings.Name)
	end
end

if SCT_Display or ( SCT and SCT.DisplayText ) then
	table.insert(consoleoptions.args.display.validate, L["Scrolling Combat Text"])
	table.insert(consoleoptions.args.display.validate, L["Scrolling Combat Text Message"])
end

WH_Options = consoleoptions

---------------------------------
--      Addon Declaration      --
---------------------------------

WitchHunt = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0", "AceConsole-2.0")

WitchHunt:RegisterDB("WitchHuntDB")
WitchHunt:RegisterDefaults('profile', defaults)
WitchHunt:RegisterChatCommand( { "/wh", "/witchhunt" }, consoleoptions )

------------------------------
--      Initialization      --
------------------------------

function WitchHunt:OnInitialize()
	self.colors = {
		Red    = {r=1, g=0, b=0}, Orange = {r=1, g=0.5, b=0},
		Yellow = {r=1, g=1, b=0}, Green  = {r=0, g=1, b=0},
		LtBlue = {r=0, g=1, b=1}, Blue   = {r=0, g=0, b=1},
		Purple = {r=1, g=0, b=1}, White  = {r=1, g=1, b=1},
		Black  = {r=0, g=0, b=0},
	}

	self.formats = {
		default = "$c: $e",
		emote = "[$c $e]",
		spell = "*$c: $e*",
	 	totem = "$c: $e",
		gain = "$c: +$e+",
		fade = "$c: -$e-",
	}
end

function WitchHunt:OnEnable()
	db = self.db.profile
	-- Setup the frame
	if not self.msgframe then self:SetupFrames() end

	if not roster and AceLibrary:HasInstance("Roster-2.1") then
		roster = AceLibrary("Roster-2.1").roster
	end

	-- Register our own events
	if db.display ~= L["None"] then
		self:RegisterEvent("WitchHunt_Message")
	end

	-- Register the WoW events
	self:RegisterEvent("CHAT_MSG_MONSTER_EMOTE")

	parser:RegisterEvent("WitchHunt", "CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE", function(event, info) self:EventHandler(event, info) end)
	parser:RegisterEvent("WitchHunt", "CHAT_MSG_SPELL_HOSTILEPLAYER_BUFF", function(event, info) self:EventHandler(event, info) end)
	parser:RegisterEvent("WitchHunt", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF", function(event, info) self:EventHandler(event, info) end)
	parser:RegisterEvent("WitchHunt", "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS", function(event, info) self:EventHandler(event, info) end)
	parser:RegisterEvent("WitchHunt", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE", function(event, info) self:EventHandler(event, info) end)
	parser:RegisterEvent("WitchHunt", "CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_BUFFS", function(event, info) self:EventHandler(event, info) end)
end

function WitchHunt:OnDisable()
	-- no more events to handle
	parser:UnregisterAllEvents("WitchHunt")
end

function WitchHunt:SetFont()
	if db.font == L["Huge"] then
		self.msgframe:SetFontObject(GameFontNormalHuge)
	elseif db.font == L["Small"] then
		self.msgframe:SetFontObject(GameFontNormalSmall)
	elseif db.font == L["Large"] then
		self.msgframe:SetFontObject(GameFontNormalLarge)
	else
		self.msgframe:SetFontObject(GameFontNormal)
	end
end

function WitchHunt:SetupFrames()
	self.dragbutton = CreateFrame("Button",nil,UIParent)
	self.dragbutton.owner = self
	self.dragbutton:Hide()
	self.dragbutton:ClearAllPoints()
	self.dragbutton:SetWidth(200)
	self.dragbutton:SetHeight(25)
	
	if db.x and db.y then
		self.dragbutton:SetPoint("TOPLEFT", UIParent, "TOPLEFT", db.x, db.y)
	else 
		self.dragbutton:SetPoint("TOP", UIErrorsFrame, "BOTTOM", 0, 0)
	end	
	self.dragbutton:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = false, tileSize = 16, edgeSize = 16,
		insets = { left = 5, right =5, top = 5, bottom = 5 }
	})
	self.dragbutton:SetBackdropColor(1,0,0,.4)	
	
	self.dragbutton:SetMovable(true)
	self.dragbutton:RegisterForDrag("LeftButton")
	self.dragbutton:SetScript("OnDragStart", function() this.owner.dragbutton:StartMoving() end )
	self.dragbutton:SetScript("OnDragStop",
		function()
			this.owner.dragbutton:StopMovingOrSizing()
			local _,_,_,x,y = this:GetPoint("CENTER")
			this.owner.db.profile.x = x
			this.owner.db.profile.y = y
		end
	)
	
	self.dragtext = self.dragbutton:CreateFontString(nil, "OVERLAY")
	self.dragtext.owner = self
	self.dragtext:SetFontObject(GameFontNormalSmall)
	self.dragtext:ClearAllPoints()
	self.dragtext:SetTextColor(1, 1, 1, 1)
	self.dragtext:SetWidth(200)
	self.dragtext:SetHeight(25)
	self.dragtext:SetPoint("TOPLEFT", self.dragbutton, "TOPLEFT")
	self.dragtext:SetJustifyH("CENTER")
	self.dragtext:SetJustifyV("MIDDLE")
	self.dragtext:SetText(L["DRAG HERE"])
	
	self.msgframe = CreateFrame("MessageFrame")
	self.msgframe.owner = self
	self.msgframe:ClearAllPoints()
	self.msgframe:SetWidth(600)
	self.msgframe:SetHeight(db.height)
	self.msgframe:SetPoint("TOP", self.dragbutton, "TOP", 0, 0)
	if db.insertmode == L["Bottom"] then
		self.msgframe:SetInsertMode("BOTTOM")
	else
		self.msgframe:SetInsertMode("TOP")
	end
	self.msgframe:SetFrameStrata("HIGH")
	self.msgframe:SetToplevel(true)

	self:UpdateLock()
	self:SetFont()

	self.msgframe:Show()
end

function WitchHunt:UpdateLock()
	if not self.msgframe then self:SetupFrames() end
	if db.lock then
		self.dragbutton:SetMovable(false)
		self.dragbutton:RegisterForDrag()
		self.msgframe:SetBackdrop(nil)
		self.msgframe:SetBackdropColor(0,0,0,0)
		self.dragbutton:Hide()
	else
		self.dragbutton:Show()
		self.dragbutton:SetMovable(true)
		self.dragbutton:RegisterForDrag("LeftButton")
		self.msgframe:SetBackdrop({
			bgFile = "Interface/Tooltips/UI-Tooltip-Background",
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
			tile = false, tileSize = 16, edgeSize = 16,
			insets = { left = 5, right =5, top = 5, bottom = 5 }
		})
		self.msgframe:SetBackdropColor(1,0,0,.4)
	end
end

function WitchHunt:IsFriendly( name )
	if roster then
		if roster[name] then return UnitIsFriend("player", roster[name].unitid) end
		return nil
	end

	local i,n,unit
	if name == UnitName("player") then
		return true
	end
	if name == UnitName("pet") and UnitIsFriend("player", "pet") then
		return true
	end
	for i = 1, 4 do
		unit = "party"..i
		if name == UnitName(unit) and UnitIsFriend("player", unit) then
			return true
		end
		unit = "partypet"..i
		if name == UnitName(unit) and UnitIsFriend("player", unit) then
			return true
		end
	end
	n = GetNumRaidMembers()
	if n > 0 then
		for i = 1, n do
			unit = "raid"..i
			if name == UnitName(unit) and UnitIsFriend("player", unit) then
				return true
			end
			unit = "raidpet"..i
			if name == UnitName(unit) and UnitIsFriend("player", unit) then
				return true
			end
		end
	end
end

function WitchHunt:GetColor( color )
	local c = (type(color) == "string" and self.colors[color]) or color
	if type(c) == "table" then
		if c[1] then return c[1], c[2], c[3]
		elseif c.r and c.g and c.b then return c.r, c.g, c.b end
	end
end

-- Burn the witch!
function WitchHunt:Burn(caster, effect, format, color)
	if not caster or not effect then return end

	-- Are we even on a hunt?
	if db.combatonly and not UnitAffectingCombat("player") then return end

	-- Check if this witch requires burning
	if self:IsFriendly(caster) then return end
	if db.targetonly then
		if not UnitExists("target") then return
		elseif UnitName("target") ~= caster then return end		
	end

	-- Can we build this pyre?
	if not self.formats[format] then format = L["Default"] end

	-- Prepare the pyre!
	local text = string.gsub( string.gsub( self.formats[format], "$c", caster), "$e", effect )

	-- Light the Fire!
	local t = GetTime()
	if ( not times[text] ) or ( times[text] and (times[text] + 3) <= t ) then
		times[text] = t
		self:TriggerEvent("WitchHunt_Message", text, color)
	end
end


-- -- -- -- -- -- -- -- -- -- -- -- -- --
-- All events we watch out for         --
-- -- -- -- -- -- -- -- -- -- -- -- -- --

local red, green, blue
local theframe

function WitchHunt:WitchHunt_Message(msg, color)
	if not msg then return end
	-- local display = db.display

	theframe = nil

	if MikSBT and db.display == L["Mik's Scrolling Battle Text"] then
		theframe = db.msbtArea
		if not theframe then
			theframe = MikSBT.DISPLAYTYPE_NOTIFICATION
		end
		red, green, blue = self:GetColor(color)
		MikSBT.DisplayMessage(msg, theframe, db.msbtSticky, red * 255, green * 255, blue * 255)
		return
	elseif ( SCT_Display or ( SCT and SCT.DisplayText ) ) and db.display == L["Scrolling Combat Text"] then
		if SCT_Display then
			SCT_Display( msg, self.colors[color] )
		else 
			SCT:DisplayText( msg, self.colors[color] )
		end
		return
	elseif ( SCT_Display or ( SCT and SCT.DisplayText ) ) and db.display == L["Scrolling Combat Text Message"] then
		if SCT_Display then
			SCT_Display_Message( msg, self.colors[color] )
		else
			SCT:DisplayMessage( msg, self.colors[color] )
		end
		return
	elseif db.display == L["Error Frame"] then
		theframe = UIErrorsFrame
	elseif db.display == L["Default"] then
		theframe = self.msgframe
	end
	if theframe then 
		red, green, blue = self:GetColor(color)
		theframe:AddMessage(msg, red or 1, green or 1, blue or 1, 1, UIERRORS_HOLD_TIME)
	end
end


function WitchHunt:CHAT_MSG_MONSTER_EMOTE(msg, monster)
	self:Burn( monster, msg:gsub("%%s", monster), "emote", "Orange")
end


function WitchHunt:EventHandler(event, info)
	if info.type == "cast" then
		if info.isBegin then
			self:Burn( info.source, info.skill, "spell", "Yellow")
		else 
			if string.find(info.skill, "Totem") then
				self:Burn( info.source, info.skill, "totem", "Green")
			else
				self:Burn( info.source, info.skill, "spell", "Purple")
			end
		end
	elseif info.type == "buff" and not info.amount then
		self:Burn( info.victim, info.skill, "gain", "LtBlue")
	end
end

